VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private WithEvents m_adoConn As ADODB.Connection
Attribute m_adoConn.VB_VarHelpID = -1

Private Const cm_sQuoteIdentifierOff As String = "set quoted_identifier off"
Private Const cm_lTimeout As Long = 120


Public Function OpenConnection(ByVal sDSN As String) As Boolean
    On Error GoTo ErrorHandler

    '' Cre une nouvelle connexion
    Set m_adoConn = New ADODB.Connection

    '' Paramtre la connexion
    m_adoConn.CursorLocation = adUseClient
    m_adoConn.CommandTimeout = cm_lTimeout
    
    '' Ouvre la connexion
    m_adoConn.Open sDSN
    
    '' Excute une requte de test
    ExecuteQuery cm_sQuoteIdentifierOff
    
    OpenConnection = True
    
    Exit Function
    
ErrorHandler:
    OpenConnection = False
End Function


Public Sub CloseConnection()
    '' Ferme la connexion
    m_adoConn.Close
End Sub


Public Sub ExecuteQuery(ByVal sSQL As String)
    On Error GoTo ErrorHandler
    
    Dim cmd As Command
    Set cmd = New Command
    
    cmd.CommandText = sSQL
    Set cmd.ActiveConnection = m_adoConn
    cmd.CommandTimeout = cm_lTimeout
    cmd.CommandType = adCmdText
    cmd.Execute
    
    Set cmd = Nothing

    Exit Sub

ErrorHandler:
    Set cmd = Nothing
    Err.Raise Err.Number
End Sub


Private Sub Class_Terminate()
    Set m_adoConn = Nothing
End Sub

Private Sub m_adoConn_ExecuteComplete(ByVal RecordsAffected As Long, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pCommand As ADODB.Command, ByVal pRecordset As ADODB.Recordset, ByVal pConnection As ADODB.Connection)
'    MsgBox "statut : " & adStatus & " - erreur : " & pError.Description
End Sub

